unit consultation;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Grids, DBGrids, Db, DBTables, StdCtrls, DBCtrls, Menus, dxCore,
  dxButton, OleCtrls, ShockwaveFlashObjects_TLB, TFlatHintUnit;

type
  Tconsult = class(TForm)
    DBGrid1: TDBGrid;
    Enfant: TTable;
    Etat: TTable;
    Cal: TTable;
    DSEnf: TDataSource;
    MenuDBG: TPopupMenu;
    N1: TMenuItem;
    Proprits1: TMenuItem;
    Modifier1: TMenuItem;
    Supprimer1: TMenuItem;
    Nouveau1: TMenuItem;
    N2: TMenuItem;
    Fermer1: TMenuItem;
    N3: TMenuItem;
    QDeces: TQuery;
    N4: TMenuItem;
    Panel2: TPanel;
    Label1: TLabel;
    Panel3: TPanel;
    dxButton1: TdxButton;
    dxButton2: TdxButton;
    dxButton3: TdxButton;
    dxButton4: TdxButton;
    dxButton5: TdxButton;
    Fermer: TButton;
    C_Nouveau: TButton;
    Supp: TButton;
    Modif: TButton;
    Proprietes: TButton;
    Panel1: TPanel;
    dxButton6: TdxButton;
    dxButton7: TdxButton;
    dxButton8: TdxButton;
    dxButton9: TdxButton;
    PSearch: TPanel;
    Image1: TImage;
    Label10: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    dxButton10: TdxButton;
    Flash1: TShockwaveFlash;
    Panel4: TPanel;
    Convoquer1: TMenuItem;
    N5: TMenuItem;
    FHint1: TFlatHint;
    procedure FermerClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure DBGrid1CellClick(Column: TColumn);
    procedure ProprietesClick(Sender: TObject);
    procedure SuppClick(Sender: TObject);
    procedure ModifClick(Sender: TObject);
    procedure Label2Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure C_NouveauClick(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure dxButton6Click(Sender: TObject);
    procedure dxButton7Click(Sender: TObject);
    procedure dxButton9Click(Sender: TObject);
    procedure dxButton8Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Convoquer1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  consult: Tconsult;
implementation

uses Principal, ProprEnfant, supprim, Modifier, ConvImpr;

{$R *.DFM}
// -----------------------------------------------------------------------------
procedure Tconsult.FermerClick(Sender: TObject);
begin
close;
end;
// -----------------------------------------------------------------------------
procedure Tconsult.FormClose(Sender: TObject; var Action: TCloseAction);
begin
form1.Panel1.enabled:=True;
form1.Quitter.enabled:=True;

Action:=cafree;
end;
// -----------------------------------------------------------------------------
procedure Tconsult.DBGrid1DrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
begin
// Change la couleur du texte et des cellules
if Enfant.recordCount<>0 then
 if gdSelected	in State then
begin
     DBGrid1.Canvas.Brush.Color := $00DFDFDF;
     DBGrid1.Canvas.Font.Color  := clNavy;
     Label1.Caption:=DBGrid1.Fields[0].Value;
  end;
DBGrid1.DefaultDrawColumnCell(Rect,DataCol,Column,State);
end;
// -----------------------------------------------------------------------------
procedure Tconsult.DBGrid1CellClick(Column: TColumn);
begin
Enfant.Refresh;
end;
// -----------------------------------------------------------------------------
procedure Tconsult.ProprietesClick(Sender: TObject);
begin
PropEnf:=TpropEnf.Create(Application);
// -----------------------------------------------------------------------------
PropEnf.Enfant.TableName:=ExtractFilePath(Application.Exename)+'Enfant.DB';
PropEnf.cal.TableName:=ExtractFilePath(Application.Exename)+'Calendier.DB';
PropEnf.Etat.TableName:=ExtractFilePath(Application.Exename)+'etatVaccinal';
//------------------------------------------------------------------------------
PropEnf.enfant.Open;
PropEnf.Enfant.Findkey([Consult.Label1.Caption]);
PropEnf.etat.open;
PropEnf.Etat.Findkey([Consult.Label1.Caption]);
PropEnf.Cal.Open;
PropEnf.cal.Findkey([Consult.Label1.Caption]);
// -----------------------------------------------------------------------------
try
PropEnf.ShowModal;
Finally
PropEnf.Free;
end;//finally
end;
// -----------------------------------------------------------------------------
procedure Tconsult.SuppClick(Sender: TObject);
begin
Supprime := TSupprime.Create(Application);
Supprime.Show;
// ---- Initialisation ---------------------------------------------------------
Supprime.Enfant.TableName:=ExtractFilePath(Application.Exename)+'Enfant.DB';
Supprime.cal.TableName:=ExtractFilePath(Application.Exename)+'Calendier.DB';
Supprime.Etat.TableName:=ExtractFilePath(Application.Exename)+'etatVaccinal.DB';
// -----------------------------------------------------------------------------
Supprime.Cvpo.Visible:=False;
Supprime.CDtcp1.Visible:=False;
Supprime.CDtcp2.Visible:=False;
Supprime.CDtcp3.Visible:=False;
Supprime.Cvar.Visible:=False;
Supprime.Cr1.Visible:=false;
Supprime.Cr2.Visible:=false;
// -----------------------------------------------------------------------------
Supprime.PBcg.visible:=false ;
Supprime.PVPO.visible:=false ;
Supprime.PDTCP1.visible:=false ;
Supprime.PDTCP2.visible:=false ;
Supprime.PDTCP3.visible:=false ;
Supprime.PVAR.visible:=false ;
Supprime.Pr1.visible:=false ;
Supprime.Pr1.visible:=false ;
// --- Ouverture des tables ----------------------------------------------------
Supprime.enfant.Open;
Supprime.Cal.open;
Supprime.etat.open;
// -----------------------------------------------------------------------------
Supprime.Enfant.Findkey([Consult.Label1.Caption]);
Supprime.Etat.Findkey([Consult.Label1.Caption]);
Supprime.cal.Findkey([Consult.Label1.Caption]);
// -----------------------------------------------------------------------------
Supprime.buttonEtatClick(Sender);
end;
// -----------------------------------------------------------------------------
procedure Tconsult.ModifClick(Sender: TObject);
begin
Modification := TModification.Create(Self);
Modification.Show;
//------------------------------------------------------------------------------
Modification.Enfant.TableName:=ExtractFilePath(Application.Exename)+'Enfant.DB';
Modification.cal.TableName:=ExtractFilePath(Application.Exename)+'Calendier.DB';
Modification.Etat.TableName:=ExtractFilePath(Application.Exename)+'etatVaccinal.DB';
// -----------------------------------------------------------------------------
form1.ConsultModif.Checked:=true;
Modification.Cvpo.Visible:=False;
Modification.CDtcp1.Visible:=False;
Modification.CDtcp2.Visible:=False;
Modification.CDtcp3.Visible:=False;
Modification.Cvar.Visible:=False;
Modification.Cr1.Visible:=false;
Modification.Cr2.Visible:=false;
// -----------------------------------------------------------------------------
Modification.PBcg.visible:=false ;
Modification.PVPO.visible:=false ;
Modification.PDTCP1.visible:=false ;
Modification.PDTCP2.visible:=false ;
Modification.PDTCP3.visible:=false ;
Modification.PVAR.visible:=false ;
Modification.Pr1.visible:=false ;
Modification.Pr1.visible:=false ;
// -----------------------------------------------------------------------------
Modification.enfant.Open;
Modification.Cal.open;
Modification.etat.open;
// -----------------------------------------------------------------------------
Modification.Enfant.Findkey([Consult.Label1.Caption]);
Modification.Etat.Findkey([Consult.Label1.Caption]);
Modification.cal.Findkey([Consult.Label1.Caption]);
// -----------------------------------------------------------------------------
Modification.enfant.Edit;
Modification.Cal.Edit;
Modification.etat.Edit;
// -----------------------------------------------------------------------------
Modification.Enregistrer.Enabled:=False;
end;
// -----------------------------------------------------------------------------
procedure Tconsult.Label2Click(Sender: TObject);
begin
Edit1.setfocus;
end;
// -----------------------------------------------------------------------------
procedure Tconsult.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
If Not (key in ['0'..'9',#8,#13]) then key:=#0;
end;
// -----------------------------------------------------------------------------
procedure Tconsult.C_NouveauClick(Sender: TObject);
begin
Consult.Close;
Form1.nouveauClick(Sender);
end;
// -----------------------------------------------------------------------------
procedure Tconsult.Edit1Change(Sender: TObject);
begin
If Edit1.Text='0' then if Length(Edit1.text)=1 then Edit1.text:='';
{ Edit1 a chang, on positionne l'enregistrement au plus proche }
{ dbut d'un "range" du BDE }
Enfant.SetRangeStart;
{ on affecte au champ index en cours le texte de Edit1 }
Enfant.FindNearest(['(01)'+edit1.text]) ;
// fin de l'opration "range" et application du rsultat }
Enfant.ApplyRange;
end;
// -----------------------------------------------------------------------------
procedure Tconsult.dxButton6Click(Sender: TObject);
begin
Enfant.First;
end;
// -----------------------------------------------------------------------------
procedure Tconsult.dxButton7Click(Sender: TObject);
begin
Enfant.Prior;
end;
// -----------------------------------------------------------------------------
procedure Tconsult.dxButton9Click(Sender: TObject);
begin
Enfant.Next;
end;
// -----------------------------------------------------------------------------
procedure Tconsult.dxButton8Click(Sender: TObject);
begin
Enfant.Last;
end;
// -----------------------------------------------------------------------------
procedure Tconsult.FormActivate(Sender: TObject);
var path : string;
begin
path := ExtractFilePath(Application.ExeName);

Res := TResourceStream.Create(hinstance,'MonFlash4',RT_RCDATA);
Res.SaveToFile(Path+'Test.swf');
Res.Free;
Flash1.Movie:=Path+'Test.swf';
deleteFile(path+'Test.swf');
end;
// -----------------------------------------------------------------------------
procedure Tconsult.Convoquer1Click(Sender: TObject);
begin
ImpConvoq:=TImpConvoq.create(application);
ImpConvoq.QRDate.Caption:=datetostr(Now+3);
ImpConvoq.QConv.Close;
ImpConvoq.QConv.SQL.clear;
ImpConvoq.QConv.SQL.add('Select * From Enfant where NEtatC="'+Label1.Caption+'"');
ImpConvoq.QConv.open;
ImpConvoq.QuickRep1.Preview;
end;
// -----------------------------------------------------------------------------
end.
