unit Principal;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ComCtrls, StdCtrls, ExtCtrls, Buttons, Grids, DBGrids, Db,
  DBTables, InspectorBar,ShellAPI, Registry, ImgList, BarMenus, BcDrawModule,
  BcCustomDrawModule, hh, hh_funcs, Bnet, OleCtrls, AgentObjects_TLB,
  TFlatHintUnit, PiconeBarreTache;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    nouveau: TButton;
    Quitter: TButton;
    Consultation: TButton;
    RechNom: TButton;
    RechhDateN: TButton;
    ButtonModif: TButton;
    ButtonSup: TButton;
    Deces: TButton;
    ConsultModif: TCheckBox;
    Convocation: TButton;
    ButGraph: TButton;
    IBar: TInspectorBar;
    SB: TStatusBar;
    Timer1: TTimer;
    BcBarMainMenu1: TBcBarMainMenu;
    MnuFile: TMenuItem;
    N13: TMenuItem;
    MnuNew: TMenuItem;
    Modification1: TMenuItem;
    Open1: TMenuItem;
    N4: TMenuItem;
    Consultation1: TMenuItem;
    N6: TMenuItem;
    CloseAll1: TMenuItem;
    N7: TMenuItem;
    Exit2: TMenuItem;
    N19: TMenuItem;
    Testing2: TMenuItem;
    N14: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Delete1: TMenuItem;
    N8: TMenuItem;
    SelectAll1: TMenuItem;
    N18: TMenuItem;
    Search1: TMenuItem;
    N15: TMenuItem;
    NumroEtatCivil1: TMenuItem;
    Find1: TMenuItem;
    FindInFiles1: TMenuItem;
    N9: TMenuItem;
    Analyse1: TMenuItem;
    N24: TMenuItem;
    LesStatistiques1: TMenuItem;
    LesConvocations1: TMenuItem;
    N23: TMenuItem;
    Archivage1: TMenuItem;
    N22: TMenuItem;
    View1: TMenuItem;
    N1: TMenuItem;
    Changer: TMenuItem;
    Ver: TMenuItem;
    N12: TMenuItem;
    Verif: TMenuItem;
    N2: TMenuItem;
    Editor11: TMenuItem;
    N41: TMenuItem;
    N2Images1: TMenuItem;
    N3Musicplayer1: TMenuItem;
    N3: TMenuItem;
    Help1: TMenuItem;
    N17: TMenuItem;
    Content1: TMenuItem;
    Topic1: TMenuItem;
    Find2: TMenuItem;
    N11: TMenuItem;
    About1: TMenuItem;
    N20: TMenuItem;
    BcCustomDrawModule1: TBcCustomDrawModule;
    PopBarTache: TBcBarPopupMenu;
    MenuItem3: TMenuItem;
    MenuItem30: TMenuItem;
    ImageMenu: TImageList;
    Agent1: TAgent;
    FHint1: TFlatHint;
    N5: TMenuItem;
    AproposdeWinVac1: TMenuItem;
    PiconeBarreTache1: TPiconeBarreTache;
    procedure nouveauClick(Sender: TObject);
    procedure QuitterClick(Sender: TObject);
    procedure ConsultationClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RechNomClick(Sender: TObject);
    procedure RechhDateNClick(Sender: TObject);
    procedure ButtonModifClick(Sender: TObject);
    procedure ButtonSupClick(Sender: TObject);
    procedure DecesClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ConvocationClick(Sender: TObject);
    procedure ButGraphClick(Sender: TObject);
    procedure IBarItemClick(Sender: TObject;
      AInspectorPanel: TInspectorPanel; AInspectorItem: TInspectorItem);
    procedure Timer1Timer(Sender: TObject);
    procedure BcCustomDrawModule1DrawMenuItem(Sender: TObject;
      AMenuItem: TMenuItem; ACanvas: TCanvas; ARect: TRect;
      State: TOwnerDrawState; ABarVisible: Boolean;
      var DefaultDraw: Boolean);
    procedure BcCustomDrawModule1MeasureMenuItem(Sender: TObject;
      AMenuItem: TMenuItem; ACanvas: TCanvas; var Width, Height: Integer;
      ABarVisible: Boolean; var DefaultMeasure: Boolean);
    procedure BcBarMainMenu1MeasureMenuItem(Sender: TObject;
      AMenuItem: TMenuItem; ACanvas: TCanvas; var Width, Height: Integer;
      ABarVisible: Boolean; var DefaultMeasure: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure Editor11Click(Sender: TObject);
    procedure N41Click(Sender: TObject);
    procedure N2Images1Click(Sender: TObject);
    procedure N3Musicplayer1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure LesStatistiques1Click(Sender: TObject);
    procedure LesConvocations1Click(Sender: TObject);
    procedure Archivage1Click(Sender: TObject);
    procedure Find1Click(Sender: TObject);
    procedure FindInFiles1Click(Sender: TObject);
    procedure MnuNewClick(Sender: TObject);
    procedure Modification1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Consultation1Click(Sender: TObject);
    procedure Exit2Click(Sender: TObject);
    procedure ChangerClick(Sender: TObject);
    procedure VerClick(Sender: TObject);
    procedure VerifClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Content1Click(Sender: TObject);
    procedure Topic1Click(Sender: TObject);
    procedure Find2Click(Sender: TObject);
  private
    FDrawBuffer: TBitmap;
    function GetDrawBuffer: TBitmap;

    function HelpHook(Command: Word; Data: LongInt; var CallHelp: Boolean): Boolean;
    { Dclarations prives }
  public
    mHelpFile: string; //Variable servant  stocker le chemin du fichier CHM
    procedure DrawGradient(Canvas: TCanvas; ARect: TRect; StartingColor,
              EndingColor: TColor; Style: TGradientStyle);
    property DrawBuffer: TBitmap read GetDrawBuffer;
    { Dclarations publiques }

  end;

var
  Form1: TForm1;
  Claude:IAgentCtlCharacterEX;
  x:String;
implementation

uses BcRectUtilities,EnfSaisie, Consultation, U_Recherche, Modifier, supprim, U_Deces,
  U_convoc, U_RaportG, APropos, Confirme, Password;

{$R ResFlash.res}
{$R *.DFM}
{$R WinXP.RES}
// -----------------------------------------------------------------------------
procedure TForm1.DrawGradient(Canvas: TCanvas; ARect: TRect; StartingColor,
  EndingColor: TColor; Style: TGradientStyle);
begin
  DrawBuffer.Height := RectHeight(ARect);
  DrawBuffer.Width := RectWidth(ARect);
  BarMenus.DrawGradient(DrawBuffer, nil, BitmapRect(DrawBuffer), startingColor, EndingColor, Style);
  Canvas.Draw(ARect.Left, ARect.Top, DrawBuffer); // copy the buffer
  DrawBuffer.Height := 0;
  DrawBuffer.Width := 0;
end;
// -----------------------------------------------------------------------------
function TForm1.GetDrawBuffer: TBitmap;
begin
  if not Assigned(FDrawBuffer) then
    FDrawBuffer := TBitmap.Create;
  Result := FDrawBuffer;
end;
// -----------------------------------------------------------------------------
function Tform1.HelpHook(Command: Word; Data: Integer; var CallHelp: Boolean): Boolean;
begin

CallHelp := False; //Dsactivation des appels  l'aide 16-bit
//Test sur le paramtre Command qui permet de savoir le type d'aide  ouvrir
if (Command in [Help_Context]) then

HtmlHelp(0, PChar(mHelpFile), HH_HELP_CONTEXT, Data) //Ouverture de l'aide
else

CallHelp := true; //En cas d'erreur, ractivation des appels  l'aide 16-bit
result := true;

end;
// --------------- Nouveau Enfant ----------------------------------------------
procedure TForm1.nouveauClick(Sender: TObject);
var i:integer;
begin
//--------CloseAll---- CloseAll----   CloseAll ----------------CloseAll
  for i := 0 to MDIChildCount - 1 do
      MDIChildren[i].Close;
//------------ --- -------------------------------------------------------------
Form1.Panel1.enabled:=false;
FormSaisie := TFormSaisie.Create(Self);
FormSaisie.ajouter.Enabled:=False;
//------------------------------------------------------------------------------
  if Assigned(formsaisie) then
     SetWindowPos(FormSaisie.Handle, HWND_TOP, 0, 0, 0, 0,
     SWP_NOSIZE or SWP_NOMOVE or SWP_SHOWWINDOW);
//------------------------------------------------------------------------------
FormSaisie.Enf.TableName:=ExtractFilePath(Application.Exename)+'Enfant.DB';
Formsaisie.cal.TableName:=ExtractFilePath(Application.Exename)+'Calendier.DB';
FormSaisie.Etat.TableName:=ExtractFilePath(Application.Exename)+'etatVaccinal.DB';
FormSaisie.Deces.TableName:=ExtractFilePath(Application.Exename)+'Deces.DB';
end;
// ------------ Fermer l'Application -------------------------------------------
procedure TForm1.QuitterClick(Sender: TObject);
begin
close;
end;
// -------------- Consultation -------------------------------------------------
procedure TForm1.ConsultationClick(Sender: TObject);
var i:integer;
begin
//------------------------------------------
   for i := 0 to MDIChildCount - 1 do
    MDIChildren[i].Close;
//------------------------------------------
  Consult := TConsult.Create(Application);
  Consult.Show;
  if Assigned(Consult) then
     SetWindowPos(Consult.Handle, HWND_TOP, 0, 0, 0, 0,
     SWP_NOSIZE or SWP_NOMOVE or SWP_SHOWWINDOW);
//------------------------------------------------------------------------------
Consult.Enfant.TableName:=ExtractFilePath(Application.Exename)+'Enfant.DB';
Consult.cal.TableName:=ExtractFilePath(Application.Exename)+'Cal.DB';
consult.Etat.TableName:=ExtractFilePath(Application.Exename)+'etat.DB';
Consult.Enfant.Active:=true;
Form1.Panel1.enabled:=False;
//------------------------------------------------------------------------------
end;

// -----------------------------------------------------------------------------
procedure TForm1.FormShow(Sender: TObject);
var i:integer;
begin
//consult.Close;
  for i := 0 to MDIChildCount - 1 do
    MDIChildren[i].Close;
end;
// -----------------------------------------------------------------------------
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
Var path: String;
begin
Action:=Canone;
if ActiveMDIChild <> nil then
begin
  action:=CaNone;
  MSG('Fermer d''abord la fentre Active ', mtWarning,[MbOk],'Note d''Avertissement',clWhite,$00A45200);
end
else begin
     action:=CaFree;
     path := ExtractFilePath(Application.ExeName);
     deleteFile(path+'Monexe.exe');
     Application.terminate;
     end;
end;
// -----------------------------------------------------------------------------
procedure TForm1.RechNomClick(Sender: TObject);
begin
F_Recherche:=TF_Recherche.create(Application);
F_Recherche.Show;
//------------------------------------------------------------------------------
F_Recherche.Enfant.TableName:=ExtractFilePath(Application.Exename)+'Enfant.DB';
F_Recherche.Enfant.Active:=true;
end;
// -----------------------------------------------------------------------------
procedure TForm1.RechhDateNClick(Sender: TObject);
begin
F_Recherche:=TF_Recherche.create(Application);
F_Recherche.show;
//------------------------------------------------------------------------------
With F_Recherche do
begin
Paneldate.Visible:=true;
Paneldate.Align:= alTop;
//Top:=0;
enfant.Active:=true;
//Paneldate.Width:=615;
P1.date:=now-30;
DBGrid2.Visible:= true;
DBGrid2.Align:= alClient;
DbNavigator1.DataSource:=DsQRech;
P2.date:=now;
P1.Maxdate:=Now;
P2.MaxDate:=Now;
end;
//--------------------

end;
// -----------------------------------------------------------------------------
procedure TForm1.ButtonModifClick(Sender: TObject);
begin
Modification := TModification.Create(Self);
Modification.Show;
Modification.Enfant.TableName:=ExtractFilePath(Application.Exename)+'Enfant.DB';
Modification.cal.TableName:=ExtractFilePath(Application.Exename)+'Calendier.DB';
Modification.Etat.TableName:=ExtractFilePath(Application.Exename)+'etatvaccinal.DB';
// -----------------------------------------------------------------------------
form1.ConsultModif.Checked:=False;
Modification.Enreg.Enabled:=false;
Modification.annul.Enabled:=false;
Modification.ferm.Visible:=true;
Modification.Cvpo.Visible:=False;
Modification.CDtcp1.Visible:=False;
Modification.CDtcp2.Visible:=False;
Modification.CDtcp3.Visible:=False;
Modification.Cvar.Visible:=False;
Modification.Cr1.Visible:=false;
Modification.Cr2.Visible:=false;
// -----------------------------------------------------------------------------
Modification.PBcg.visible:=false ;
Modification.PVPO.visible:=false ;
Modification.PDTCP1.visible:=false ;
Modification.PDTCP2.visible:=false ;
Modification.PDTCP3.visible:=false ;
Modification.PVAR.visible:=false ;
Modification.Pr1.visible:=false ;
Modification.Pr1.visible:=false ;
// -----------------------------------------------------------------------------
Modification.DBNom.ReadOnly:=true;
Modification.DBprenom.ReadOnly:=true;
Modification.DBSexe.ReadOnly:=true;
Modification.DBpere.ReadOnly:=true;
Modification.PDATEN.Enabled:=false;
Modification.DBlieu.ReadOnly:=true;
Modification.adresse.ReadOnly:=true;
Modification.Observ.ReadOnly:=true;
Modification.GroupBox1.enabled:=False;
// -----------------------------------------------------------------------------
Modification.enfant.Close;
Modification.Cal.Close;
Modification.etat.Close;
// -----------------------------------------------------------------------------
Modification.PSearch.visible:=true;
// -----------------------------------------------------------------------------
Modification.Edit1.Setfocus;
Modification.Enregistrer.Enabled:=False;
end;
// -----------------------------------------------------------------------------
procedure TForm1.ButtonSupClick(Sender: TObject);
begin
Supprime := TSupprime.Create(Application);
Supprime.Show;
//---- Initialisation ----------------------------------------------------------

Supprime.Cvpo.Visible:=False;
Supprime.CDtcp1.Visible:=False;
Supprime.CDtcp2.Visible:=False;
Supprime.CDtcp3.Visible:=False;
Supprime.Cvar.Visible:=False;
Supprime.Cr1.Visible:=false;
Supprime.Cr2.Visible:=false;
// -----------------------------------------------------------------------------
Supprime.PBcg.visible:=false ;
Supprime.PVPO.visible:=false ;
Supprime.PDTCP1.visible:=false ;
Supprime.PDTCP2.visible:=false ;
Supprime.PDTCP3.visible:=false ;
Supprime.PVAR.visible:=false ;
Supprime.Pr1.visible:=false ;
Supprime.Pr1.visible:=false ;
// Ouverture des tables --------------------------------------------------------
Supprime.enfant.close;
Supprime.Cal.Close;
Supprime.etat.close;
Supprime.ButtonSup.Enabled:=false;
Supprime.PSearch.Visible:=true;
Supprime.Edit1.SetFocus;
end;
// -----------------------------------------------------------------------------
procedure TForm1.DecesClick(Sender: TObject);
var i:integer;
begin
//--------CloseAll---- CloseAll----   CloseAll ----------------CloseAll
  for i := 0 to MDIChildCount - 1 do
      MDIChildren[i].Close;
F_Deces:= TF_Deces.create(application);
F_Deces.show;
//------------------------------------------------------------------------------
F_Deces.Enfant.TableName:=ExtractFilePath(Application.Exename)+'Enfant.DB';
F_Deces.Deces.TableName:=ExtractFilePath(Application.Exename)+'Deces.DB';
F_Deces.Deces.Active:=true;
If F_Deces.Deces.RecordCount=0 then
begin
F_deces.ToutSup.Enabled:=false;
F_deces.Sup.enabled:=false;
F_deces.Supprimer1.Enabled:=false;
F_deces.Rcuprer1.Enabled:=False;
F_deces.ToutSupprimer1.Enabled:=false;
End;{RecordCount=0 }
F_Deces.Enfant.Active:=true;
If  F_Deces.Enfant.RecordCount=0 then  F_Deces.Dcder1.Enabled:=false
Else F_Deces.Dcder1.Enabled:=True;
//------------------------------------------------------------------------------
end;
// -----------------------------------------------------------------------------
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
if ActiveMDIChild = nil then
Canclose :=   MSG('Etes vous sr de vouloir quitter le logiciel ',mtConfirmation,[mbyes,mbNo],'Fermeture du logiciel',clblack,$00CAE6D9)=mryes;
end;
// -----------------------------------------------------------------------------
procedure TForm1.ConvocationClick(Sender: TObject);
var i:integer;
begin
//--------CloseAll---- CloseAll----   CloseAll ----------------CloseAll
  for i := 0 to MDIChildCount - 1 do
      MDIChildren[i].Close;
//--------------------------------------------------------------------
F_Convocation:=TF_Convocation.Create(application);
F_Convocation.show;
end;
// -----------------------------------------------------------------------------
procedure TForm1.ButGraphClick(Sender: TObject);
var i:integer;
begin
//-------- Close All -----------------------------------------------------------
  for i := 0 to MDIChildCount - 1 do
      MDIChildren[i].Close;
//------------------------------------------------------------------------------
F_RapGraph:=TF_RapGraph.create(Application);
F_RapGraph.show;
end;
// -----------------------------------------------------------------------------
procedure TForm1.IBarItemClick(Sender: TObject;
  AInspectorPanel: TInspectorPanel; AInspectorItem: TInspectorItem);
begin
Case AInspectorPanel.Index of
// ---------- Saisie des Donnes -----------------------------------------------
0: begin
    Case AInspectorItem.Index of
    0:begin
      nouveauClick(Sender);
      end;
    1:begin
      ButtonModifClick(Sender);
      end;
    2:begin
      ButtonSupClick(Sender);
      end;
    3:begin
      ConsultationClick(Sender);
      end;
    End;
   End;
// ----------- La Recherche ----------------------------------------------------
1: Begin
    Case AInspectorItem.Index of
    0:begin
      RechNomClick(Sender);
      end;
    1:begin
      RechhDateNClick(Sender);
      end;
    End;
   End;
// ---------- Analyse ----------------------------------------------------------
2: begin
    Case AInspectorItem.Index of
    0:begin
      ConvocationClick(Sender);
      end;
    1:begin
      ButGraphClick(Sender);
      end;
    2:begin
      DecesClick(Sender);
      end;
    End;
   End;
// ------------- Outils --------------------------------------------------------
3: begin
    Case AInspectorItem.Index of
    0:begin
     Editor11Click(Sender);
      end;
    1:begin
      N41Click(Sender);
      end;
    2:begin
      N2Images1Click(Sender);
      end;
    3:begin
      N3Musicplayer1Click(Sender);
      end;
    End;
   End;
// -----------------------------------------------------------------------------
End;
end;
// -----------------------------------------------------------------------------
procedure TForm1.Timer1Timer(Sender: TObject);
begin
Sb.Panels[1].Text := formatdatetime('dddddd',now);
sb.Panels[2].Text:=Timetostr(Now);
end;
// -----------------------------------------------------------------------------
procedure TForm1.BcCustomDrawModule1DrawMenuItem(Sender: TObject;
  AMenuItem: TMenuItem; ACanvas: TCanvas; ARect: TRect;
  State: TOwnerDrawState; ABarVisible: Boolean; var DefaultDraw: Boolean);
var
  R: TRect;
  ImageList: TCustomImageList;
  // --------------------------------------------
  procedure DrawCheckedPattern(Inflate: Boolean);
  begin
    if odChecked in State then
    begin
      if Inflate then InflateRect(R, -2, -2);
      ACanvas.Brush.Color := clred;
      ACanvas.FrameRect(R);
      if Inflate then InflateRect(R, 2, 2);
    end;
  end;
  // --------------------------------------------
begin
  DefaultDraw := False;
  { menuitem drawing }
  if (AMenuItem.Caption = cLineCaption) then
  begin
    { background }
    DrawGradient(ACanvas, ARect, clWhite, clBtnFace, gsHorizontal);

    { align the text and draw it }
    R := ARect;
    R.Left := R.Right - ACanvas.TextWidth(AMenuItem.Hint) - 15;
    ACanvas.Brush.Style := bsClear;
    DrawText(ACanvas.Handle,
      PChar(AMenuItem.Hint), Length(AMenuItem.Hint),
      R, 0);

    { draw the line so that it won't draw over text }
    R := ARect;
    Inc(R.Top, (R.Bottom - R.Top) div 2);
    R.Bottom := R.Top + 1;
    Dec(R.Right, ACanvas.TextWidth(AMenuItem.Hint) + 10 + 10);
    ACanvas.Brush.Color := clred; // Pour les sparateurs
    ACanvas.FillRect(R);
  end else
  begin
    { use default drawing for mainmenu top items }
    if IsInTopMainMenu(AMenuItem) then
    begin
      DefaultDraw := True;
      Exit;
    end;
    with ACanvas do
    begin
      R := ARect;
      if odSelected in State then
      begin
        { draw frame and selection gradient }
        Brush.Color := clBlue;// Pour l'encadrement du selectionnement
        FrameRect(R);
        InflateRect(R, -2, -2);
        DrawGradient(ACanvas, R, clWhite, AMenuItem.Tag, gsDiagonalLeftRight);
        DrawCheckedPattern(False);
        { adjust rect so that text will be aligned to right }
        R.Left := R.Right - TextWidth(AMenuItem.Caption) - 5;
        Font.Color := clWhite; // caption color
      end else
      begin
        { draw background gradient }
        DrawGradient(ACanvas, R, clWhite, clBtnFace, gsHorizontal);
        DrawCheckedPattern(True);
        { leave space for menuitem image }
        Inc(R.Left, 38);
        Font.Color := clBlack; // caption color
      end;
      if (odDisabled in State) or (odGrayed in State) then
        Font.Color := clSilver;   // Pour les menus dsactivs

      { draw caption }
      InflateRect(R, 0, -(
        (R.Bottom - R.Top - TextHeight(AMenuItem.Caption) - 1)
         div 2));
      Brush.Style := bsClear;
      DrawText(Handle,
        PChar(AMenuItem.Caption), Length(AMenuItem.Caption),
        R, 0);

      { draw menuitem image }
      with AMenuItem do
      begin
        ImageList := GetImageList;
        if (ImageIndex <> -1) and Assigned(ImageList) then
          ImageList.Draw(ACanvas, ARect.Left + 11,
            ARect.Top + (ARect.Bottom - ARect.Top - ImageList.Height) div 2, ImageIndex);
      end;
    end;
  end;
end;
// -----------------------------------------------------------------------------
procedure TForm1.BcCustomDrawModule1MeasureMenuItem(Sender: TObject;
  AMenuItem: TMenuItem; ACanvas: TCanvas; var Width, Height: Integer;
  ABarVisible: Boolean; var DefaultMeasure: Boolean);
begin
  if not IsInTopMainMenu(AMenuItem) then
  begin
    DefaultMeasure := False;
    if not (AMenuItem.Caption = cLineCaption) then
    begin
      Height := 22;
      Width := Width + 32;
    end;
  end;
end;
// -----------------------------------------------------------------------------
procedure TForm1.BcBarMainMenu1MeasureMenuItem(Sender: TObject;
  AMenuItem: TMenuItem; ACanvas: TCanvas; var Width, Height: Integer;
  ABarVisible: Boolean; var DefaultMeasure: Boolean);
begin
  if (GetMenuBarMenusIntf(TMenu(Sender)).UseMenuStyle = msWindowsXP) then
      Height := Height + 2;
      Width := Width + 10;
end;
// -----------------------------------------------------------------------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
  FreeAndNil(FDrawBuffer);
end;
// -----------------------------------------------------------------------------
procedure TForm1.Editor11Click(Sender: TObject);
begin
winexec('Explorer.exe',sw_normal);
end;
// -----------------------------------------------------------------------------
procedure TForm1.N41Click(Sender: TObject);
var h:THandle;
cName:shortstring;
begin
h:=FindWindow('SciCalc','Calculatrice');
if h = 0 then
ShellExecute(0,nil,'Calc.exe',nil,nil,cmdShow)
else
begin
cName[0]:=chr(GetClassName(h,@cName[1],255));
BringWindowToTop(h);
end;
end;
// -----------------------------------------------------------------------------
procedure TForm1.N2Images1Click(Sender: TObject);
begin
winexec('notepad.exe',sw_normal);
end;
// -----------------------------------------------------------------------------
procedure TForm1.N3Musicplayer1Click(Sender: TObject);
begin
  ShellExecute(Handle, 'Open', 'Control', 'Date/Time', '', SW_SHOW);
end;
// -----------------------------------------------------------------------------
procedure TForm1.About1Click(Sender: TObject);
begin
Claude.Play('Explain');
Claude.Speak('A propos du WinVac.','');
Propos.ShowModal;
end;
// -----------------------------------------------------------------------------
procedure TForm1.LesStatistiques1Click(Sender: TObject);
begin
ButGraphClick(Sender);
end;
// -----------------------------------------------------------------------------
procedure TForm1.LesConvocations1Click(Sender: TObject);
begin
ConvocationClick(Sender);
end;
// -----------------------------------------------------------------------------
procedure TForm1.Archivage1Click(Sender: TObject);
begin
DecesClick(Sender);
end;
// -----------------------------------------------------------------------------
procedure TForm1.Find1Click(Sender: TObject);
begin
RechNomClick(Sender);
end;
// -----------------------------------------------------------------------------
procedure TForm1.FindInFiles1Click(Sender: TObject);
begin
 RechhDateNClick(Sender);
end;
// -----------------------------------------------------------------------------
procedure TForm1.MnuNewClick(Sender: TObject);
begin
nouveauClick(Sender);
end;
// -----------------------------------------------------------------------------
procedure TForm1.Modification1Click(Sender: TObject);
begin
ButtonModifClick(Sender);
end;
// -----------------------------------------------------------------------------
procedure TForm1.Open1Click(Sender: TObject);
begin
ButtonSupClick(Sender);
end;
// -----------------------------------------------------------------------------
procedure TForm1.Consultation1Click(Sender: TObject);
begin
ConsultationClick(Sender);
end;
// -----------------------------------------------------------------------------
procedure TForm1.Exit2Click(Sender: TObject);
begin
Close;
end;
// -----------------------------------------------------------------------------
procedure TForm1.ChangerClick(Sender: TObject);
begin
ChangePasse.ShowModal;
end;
// -----------------------------------------------------------------------------
procedure TForm1.VerClick(Sender: TObject);
begin
MotDePasse.Edit1.Text := '';
MotDePasse.show;
MotDePasse.Edit1.setfocus;
MotDePasse.Button2.Enabled := false;
MotDePasse.Button1.Caption := 'Dverrouiller';
Form1.hide;
end;

procedure TForm1.VerifClick(Sender: TObject);
var
   Reg: TRegIniFile;
begin
if not (Verif.Checked) then
begin
Verif.Checked:= true;
Verif.Caption:= 'Dsactiver le mot de passe';
ver.Enabled:= true;
x:='True';
end Else
    Begin
    Verif.Checked := false;
    Verif.Caption:= 'Activer le mot de passe';
    Ver.Enabled:= false;
    x:='False';
    End;
// ------ Montr / Pas Montr la premiere fentre ------------------------------
reg := TRegIniFile.Create;
reg.RootKey := HKEY_CLASSES_ROOT;
reg.WriteString('.aaa','Active',x);
reg.CloseKey;
reg.free;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
MotDePasse.hide;
Claude.MoveTo(250,500,1000);//24 68 sont des valeurs en pixels , 1000 dsigne la vitesse de dplacement de l'agent
Claude.Play('Wave');
Claude.Speak('Salut, je m''appelle Claude','');
Claude.Play('GestureRight');
Claude.Speak('Bon, choisissez un traitement parmis cette liste SVP','');

end;

procedure TForm1.FormCreate(Sender: TObject);
Var
  path,Test: String;
  Reg: TRegIniFile;
Begin
path := ExtractFilePath(Application.ExeName);  // Rcupr le chemein de l'executable
reg := TRegIniFile.Create;
reg.RootKey := HKEY_CLASSES_ROOT;
Test:=reg.ReadString('.aaa','Active','');
reg.CloseKey;
reg.free;
 If Test='True' then begin
                     Verif.Checked:= true;
                     Verif.Caption:= 'Dsactiver le mot de passe';
                     Ver.Enabled:= True;
                     end
 else Begin
      Verif.Checked:= False;
      Verif.Caption:= 'Activer le mot de passe';
      Ver.Enabled:= false;
      End;
// --------- Pour l'aide CHM ---------------------------------------------------
//Redirection des appels  l'aide 16-bit vers notre gestionnaire d'vnement
Application.OnHelp := HelpHook;
//Recherche du chemin du fichier d'aide
mHelpFile := ExtractFilePath(ParamStr(0)) + '\SysFiles\Help.chm';
mHelpFile := ExpandFileName(mHelpFile);
if not FileExists(mHelpFile) then //Dclench si le fichier d'aide est introuvable
    MSG('Le fichier d''aide est introuvable !',mtWarning,[MbOk],'Note d''Avertissement',clWhite,$00A45200);
    //  ShowMessage('Le fichier d''aide est introuvable !');
//Vrification de la version de HTML Help install dans le systme
if (hh.HHCtrlHandle = 0)
or (hh_funcs._hhMajVer < 4)
or ((hh_funcs._hhMajVer = 4) and (hh_funcs._hhMinVer < 73)) then
    MSG('Vous devez installer la version 1.2 ou suprieure de Microsoft HTML Help !', mtInformation,[MbOk],'Remarque d''Information ...!!!',clblack,$00E4ECF1);
    //  ShowMessage('Vous devez installer la version 1.2 ou suprieure de Microsoft HTML Help !');
// ---------- Le MSAgent -------------------------------------------------------
Agent1.Connected:=True;
Agent1.Characters.Load('Claude', path+'\SysFiles\claude.acs');// on charge Claude
Claude:=IAgentCtlCharacterEX(Agent1.Characters.Character('Claude'));//Claude est dsign comme agent de l'application
Claude.Show(False); // Pour le faire apparatre.
Claude.LanguageID:=$40C;//Pour indiquer que Claude doit parler en franais
// -----------------------------------------------------------------------------
end;
// -----------------------------------------------------------------------------
procedure TForm1.Content1Click(Sender: TObject);
begin
Claude.Speak('Vous avez choisi l''Aide','');
HtmlHelp(0, PChar(mHelpFile), HH_DISPLAY_TOC, 0); //HH_DISPLAY_TOC est l'appel au sommaire
end;
// -----------------------------------------------------------------------------
procedure TForm1.Topic1Click(Sender: TObject);
begin
HtmlHelp(0, PChar(mHelpFile), HH_DISPLAY_INDEX, 0); //HH_DISPLAY_INDEX est l'appel  l'index
end;
// -----------------------------------------------------------------------------
procedure TForm1.Find2Click(Sender: TObject);
var
q: THHFtsQuery; //Type interne  l'unit hh.pas
begin
//Dfinition de la requte
with q do
begin
cbStruct := sizeof(q); //Taille de la requte
fUniCodeStrings := false; //mettre  true si toute la chane recherche est de type Unicode
pszSearchQuery := nil; //chane recherche
iProximity := HH_FTS_DEFAULT_PROXIMITY; //Recherche en respectant les mots similaires
fStemmedSearch := false; //mettre  true pour rechercher dans les rsultats prcdents
fTitleOnly := false; //mettre  true si la recherche se fait uniquement sur les titres de rubriques
fExecute := true; //mettre  true pour excuter la requte
pszWindow := nil; //type de fentre  afficher, ici c'est celle par dfaut
end;
HtmlHelp(0, PChar(mHelpFile), HH_DISPLAY_SEARCH, DWORD(@q)); //HH_DISPLAY_SEARCH est l'appel  la recherche
end;

end.
