unit U_Deces;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, StdCtrls, Grids, DBGrids, Buttons, ExtCtrls, Menus, dxCore,
  dxButton,Bnet, TFlatHintUnit;

type
  TF_Deces = class(TForm)
    Batch: TBatchMove;
    Deces: TTable;
    DecesNEtatC: TStringField;
    DecesNom: TStringField;
    DecesPrenom: TStringField;
    DecesDateN: TDateField;
    DecesSexe: TStringField;
    DecesNomPere: TStringField;
    DecesLieuN: TStringField;
    DecesAdresse: TStringField;
    DecesObserv: TStringField;
    DSQEnf: TDataSource;
    DSDeces: TDataSource;
    QEnfant: TQuery;
    Enfant: TTable;
    EnfantNEtatC: TStringField;
    EnfantNom: TStringField;
    EnfantPrenom: TStringField;
    EnfantDateN: TDateField;
    EnfantSexe: TStringField;
    EnfantNompere: TStringField;
    EnfantLieuN: TStringField;
    EnfantAdresse: TStringField;
    EnfantObserv: TStringField;
    DSenfant: TDataSource;
    Label1: TLabel;
    Label2: TLabel;
    GroupBox1: TGroupBox;
    DBGrid2: TDBGrid;
    Panel1: TPanel;
    Edit2: TEdit;
    GroupBox2: TGroupBox;
    DBGrid1: TDBGrid;
    Panel2: TPanel;
    Edit1: TEdit;
    DecesRech: TSpeedButton;
    PrincRech: TSpeedButton;
    TmpCal: TTable;
    DSTmpCal: TDataSource;
    TmpEtat: TTable;
    DSTmpEtat: TDataSource;
    Cal: TTable;
    DSCal: TDataSource;
    Etat: TTable;
    DSEtat: TDataSource;
    EtatDeces: TTable;
    DNEtatC: TStringField;
    DateD: TDateField;
    deplaceDeces: TTable;
    DeplaceCal: TTable;
    deplaceEtat: TTable;
    PopupMenuE: TPopupMenu;
    Dcder1: TMenuItem;
    PopupMenuD: TPopupMenu;
    Rcuprer1: TMenuItem;
    Supprimer1: TMenuItem;
    ToutSupprimer1: TMenuItem;
    N1: TMenuItem;
    Panel3: TPanel;
    Recup: TButton;
    Sup: TButton;
    toutSup: TButton;
    Panel4: TPanel;
    BouttonDeces: TButton;
    dxButton1: TdxButton;
    dxButton2: TdxButton;
    dxButton3: TdxButton;
    dxButton4: TdxButton;
    dxButton5: TdxButton;
    Fermer: TButton;
    FHint1: TFlatHint;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PrincRechClick(Sender: TObject);
    procedure BouttonDecesClick(Sender: TObject);
    procedure RecupClick(Sender: TObject);
    procedure DecesRechClick(Sender: TObject);
    procedure DBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure DBGrid2DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure FermerClick(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure DBGrid1CellClick(Column: TColumn);
    procedure DBGrid2CellClick(Column: TColumn);
    procedure SupClick(Sender: TObject);
    procedure toutSupClick(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  F_Deces: TF_Deces;
implementation

uses U_DateDeces;

{$R *.DFM}

procedure TF_Deces.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Action := CaFree;
end;
// -----------------------------------------------------------------------------
procedure TF_Deces.PrincRechClick(Sender: TObject);
begin
QEnfant.close;
QEnfant.SQL.clear;
QEnfant.sql.Add('Select * From Enfant.DB Where NEtatC=:x');
QEnfant.Params[0].AsString := '(01)'+Edit1.text;
QEnfant.Open;
Enfant.FindKey(['(01)'+Edit1.text]);
if QEnfant.RecordCount = 0 then
begin
MSG('Ce Numro d''tat Civil n''xiste pas ... !!!', mtInformation,[MbOk],'Remarque d''Information ...!!!',clblack,$00E4ECF1);
// showmessage('Ce Numro d''tat Civil n''xiste pas ............. !!!');
BouttonDeces.Enabled:=False;
end
Else BouttonDeces.Enabled:=True;
end;
// -----------------------------------------------------------------------------
procedure TF_Deces.BouttonDecesClick(Sender: TObject);
begin
F_Datedeces:=TF_DateDeces.create(application);
F_Datedeces.PickerDeces.date:=now-1;
Try
F_Datedeces.ShowModal;
Finally
Etatdeces.open;
EtatDeces.insert;
dateD.value:=F_Datedeces.PickerDeces.date;
DNEtatC.value:=Label1.caption;
F_Datedeces.Free;
end;
//------------------------------------------------------------------------------
Etatdeces.post;
EtatDeces.close;
//------------------------------------------------------------------------------
Batch.Source:= QEnfant;
Batch.Destination:= Deces;
Batch.Execute;
//------------------------------------------------------------------------------
QEnfant.close;
QEnfant.SQL.clear;
QEnfant.sql.Add('Select * From EtatVaccinal.DB Where NEtatC=:x');
QEnfant.Params[0].AsString := Label1.Caption;
QEnfant.Open;
Etat.FindKey([Label1.Caption]);

Batch.Source:= QEnfant;
Batch.Destination:=TmpEtat;
Batch.Execute;
//------------------------------------------------------------------------------
QEnfant.close;
QEnfant.SQL.clear;
QEnfant.sql.Add('Select * From Calendier.DB Where NEtatC=:x');
QEnfant.Params[0].AsString := Label1.Caption;
QEnfant.Open;
Cal.FindKey([Label1.Caption]);

Batch.Source:= QEnfant;
Batch.Destination:= TmpCal;
Batch.Execute;
//------------------------------------------------------------------------------
Cal.open;
Etat.open;
//------------------------------------------------------------------------------
if Enfant.FindKey([Label1.caption]) then Enfant.delete;
if Cal.FindKey([Label1.caption]) then Cal.delete;
if Etat.FindKey([Label1.caption]) then Etat.delete;
Enfant.Refresh;
DBGrid1.Refresh;
QEnfant.Refresh;
BouttonDeces.enabled:=False;
ToutSup.Enabled:=True;
ToutSupprimer1.Enabled:=True;
Rcuprer1.Enabled:=True;
Supprimer1.Enabled:=True;
end;
// -----------------------------------------------------------------------------
procedure TF_Deces.RecupClick(Sender: TObject);
begin
Batch.Source:= QEnfant;
Batch.Destination:= Enfant;
Batch.Execute;
//------------------------------------------------------------------------------
QEnfant.close;
QEnfant.SQL.clear;
QEnfant.sql.Add('Select * From TmpEtatVaccinal.DB Where NEtatC=:x');
QEnfant.Params[0].AsString := Label2.Caption;
QEnfant.Open;
TmpEtat.open;
TmpEtat.FindKey([Label2.Caption]);

Batch.Source:= QEnfant;
Batch.Destination:= Etat;
Batch.Execute;
//------------------------------------------------------------------------------
QEnfant.close;
QEnfant.SQL.clear;
QEnfant.sql.Add('Select * From TmpCalendier.DB Where NEtatC=:x');
QEnfant.Params[0].AsString := Label2.Caption;
QEnfant.Open;
TmpCal.open;
TmpCal.FindKey([Label2.Caption]);

Batch.Source:= QEnfant;
Batch.Destination:= Cal;
Batch.Execute;
//------------------------------------------------------------------------------
EtatDeces.open;
//------------------------------------------------------------------------------
if Deces.FindKey([Label2.caption]) then Deces.delete;
if TmpCal.FindKey([Label2.caption]) then TmpCal.delete;
if TmpEtat.FindKey([Label2.caption]) then tmpEtat.delete;
if EtatDeces.FindKey([Label2.caption]) then EtatDeces.delete;
//------------------------------------------------------------------------------
Deces.Refresh;
DBGrid2.Refresh;
Recup.Enabled:= false;
If F_Deces.Deces.RecordCount=0 then
begin
Rcuprer1.Enabled:=False;
Toutsupprimer1.Enabled:=False;
Supprimer1.Enabled:=False;
 End {Deces.RecordCount}
Else begin
Rcuprer1.Enabled:=True;
Toutsupprimer1.Enabled:=True;
Supprimer1.Enabled:=True;
end;
end;
// -----------------------------------------------------------------------------
procedure TF_Deces.DecesRechClick(Sender: TObject);
begin
QEnfant.close;
QEnfant.SQL.clear;
QEnfant.sql.Add('Select * From Deces.DB Where NEtatC=:x');
QEnfant.Params[0].AsString := '(01)'+Edit2.text;
QEnfant.Open;
Deces.FindKey(['(01)'+Edit2.text]);
if QEnfant.RecordCount = 0 then
MSG('Ce Numro d''tat Civil n''xiste pas ... !!!', mtInformation,[MbOk],'Remarque d''Information ...!!!',clblack,$00E4ECF1)
// showmessage('Ce Numro d''tat civil n''xiste pas ............. !!!')
else Recup.Enabled := true;
end;
// -----------------------------------------------------------------------------
procedure TF_Deces.DBGrid1DrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
begin
// Change la couleur du texte et des cellules
if Enfant.RecordCount<>0 then
 if gdSelected	in State then
begin
//------------------------------------------------------------------------------
QEnfant.close;
QEnfant.SQL.clear;
QEnfant.sql.Add('Select * From Enfant.DB Where NEtatC=:x');
QEnfant.Params[0].AsString := DBGrid1.Fields[0].Value;
QEnfant.Open;
//------------------------------------------------------------------------------
     DBGrid1.Canvas.Brush.Color := $00DFDFDF;
     DBGrid1.Canvas.Font.Color  := clNavy;
     Label1.Caption:=DBGrid1.Fields[0].Value;
       end;
DBGrid1.DefaultDrawColumnCell(Rect,DataCol,Column,State);
end;
// -----------------------------------------------------------------------------
procedure TF_Deces.DBGrid2DrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
begin
// Change la couleur du texte et des cellules
if Deces.RecordCount<>0 then
 if gdSelected	in State then
begin

QEnfant.close;
QEnfant.SQL.clear;
QEnfant.sql.Add('Select * From Deces.DB Where NEtatC=:x');
QEnfant.Params[0].AsString := DBGrid2.Fields[0].Value;
QEnfant.Open;
// -----------------------------------------------------------------------------
     DBGrid2.Canvas.Brush.Color := $00DFDFDF;
     DBGrid2.Canvas.Font.Color  := clNavy;
     Label2.Caption:=DBGrid2.Fields[0].Value;
  end;
DBGrid2.DefaultDrawColumnCell(Rect,DataCol,Column,State);
end;
// -----------------------------------------------------------------------------
procedure TF_Deces.FermerClick(Sender: TObject);
begin
close;
end;
// -----------------------------------------------------------------------------
procedure TF_Deces.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
if not (key in ['0'..'9',#8,#13]) then key:=#0 ;
if key =#13 then
PrincRechClick(sender);
end;
// -----------------------------------------------------------------------------
procedure TF_Deces.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
if not (key in ['0'..'9',#8,#13]) then key:=#0 ;
if key =#13 then
DecesRechClick(sender);
end;
// -----------------------------------------------------------------------------
procedure TF_Deces.DBGrid1CellClick(Column: TColumn);
begin
if Enfant.RecordCount<>0 then
begin
BouttonDeces.enabled:=True;
Dcder1.Enabled:=True;
end;
end;
// -----------------------------------------------------------------------------
procedure TF_Deces.DBGrid2CellClick(Column: TColumn);
begin
if Deces.RecordCount<>0 then
begin
Recup.Enabled:= True;
Sup.Enabled:=True;
Supprimer1.Enabled:=True;
end;
end;
// -----------------------------------------------------------------------------
procedure TF_Deces.SupClick(Sender: TObject);
begin
IF MSG('Vous tes sr de vouloir Supprimer Cet Enregistrement ?',mtConfirmation,[MbYes,MbNo],'Confirmation ...',clNavy,$00E8E8E8)=MrYes then
//Messagedlg('Vous tes sr de vouloir Supprimer Cet Enregistrement ?',MtConfirmation,[MbYes,MbNo],0)=MrYes then
begin
If Deces.FindKey([Label2.caption]) then
begin
deces.Delete;
If TmpCal.FindKey([Label2.caption]) then
Tmpcal.Delete;
If Tmpetat.FindKey([Label2.caption]) then
TmpEtat.Delete;
Deces.Refresh;
end;//then
end;{Messagedlg}
end;
// -----------------------------------------------------------------------------
procedure TF_Deces.toutSupClick(Sender: TObject);
begin
If MSG('Etes Vous sr de vouloir Vider la Tables des Dcs ?',mtConfirmation,[MbYes,MbNo],'Confirmation ...',clNavy,$00E8E8E8)=MrYes then
// MessageDlg('Vous tes sr de vouloir Vider la Tables des deces ?',MtConfirmation,[MbYes,MbNo],0)=MrYes then
begin
DeplaceDeces.active:=False;
Deces.Active:=False;
Batch.Destination:=deplaceDeces;
Batch.Source:=deces;
Deces.EmptyTable;
Batch.Execute;
Deces.active:=True;
Deces.Refresh;
//------------------------------------------------------------------------------
DeplaceCal.active:=False;
TmpCal.Active:=False;
Batch.Destination:=deplaceCal;
Batch.Source:=TmpCal;
TmpCal.EmptyTable;
Batch.Execute;
//------------------------------------------------------------------------------
DeplaceEtat.active:=False;
TmpEtat.Active:=False;
Batch.Destination:=deplaceEtat;
Batch.Source:=TmpEtat;
TmpEtat.EmptyTable;
Batch.Execute;
//------------------------------------------------------------------------------
End; {MessageDlg }
end;
// -----------------------------------------------------------------------------
procedure TF_Deces.Edit1Change(Sender: TObject);
begin
If Edit1.Text='0' then if Length(Edit1.text)=1 then Edit1.text:='';
end;
// -----------------------------------------------------------------------------
procedure TF_Deces.Edit2Change(Sender: TObject);
begin
If Edit2.Text='0' then if Length(Edit2.text)=1 then Edit1.text:='';
end;
// -----------------------------------------------------------------------------
end.
