unit U_convoc;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, Grids, DBGrids, StdCtrls, ExtCtrls, DBCtrls, dxCore, Bnet,
  dxButton, OleCtrls, ShockwaveFlashObjects_TLB, TFlatHintUnit;

type
  TF_convocation = class(TForm)
    RG: TRadioGroup;
    Qconvoc: TQuery;
    DSQ: TDataSource;
    Ferm: TButton;
    Convoquer: TButton;
    DBNavigator1: TDBNavigator;
    Label1: TLabel;
    dxButton1: TdxButton;
    dxButton2: TdxButton;
    Panel3: TPanel;
    Flash1: TShockwaveFlash;
    Panel4: TPanel;
    DBGrid1: TDBGrid;
    FHint1: TFlatHint;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RGClick(Sender: TObject);
    procedure FermClick(Sender: TObject);
    procedure DBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure ConvoquerClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  F_convocation: TF_convocation;
  Res : TResourceStream;
implementation

uses ConvImpr;

{$R *.DFM}

procedure TF_convocation.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
Action:=Cafree;
end;

procedure TF_convocation.RGClick(Sender: TObject);
begin
Case rg.ItemIndex of
0:begin
  Qconvoc.close;
  Qconvoc.SQL.Clear;
  Qconvoc.sql.Add('Select * from enfant,EtatVaccinal ');
  Qconvoc.sql.Add( 'Where EtatVaccinal.NEtatc=Enfant.NEtatC and EtatVaccinal.bcg="Non Administr" and Enfant.DateN Between :x And :y ');
  Qconvoc.Params[0].AsDate:=Now-365;
  Qconvoc.Params[1].AsDate:=now;
  Qconvoc.Open;
  Label1.Caption:=intToStr(QConvoc.RecordCount);
  if QConvoc.RecordCount=0 then       begin
  MSG('Aucune Rsultat a afficher pour les enfants ns entre le '+DateToStr(now-365)+' et le '+DateToStr(now)+' .',mtInformation,[MbOk],'Remarque d''Information ...!!!',clblack,$00E4ECF1);
  // Messagedlg('Aucune Rsultat a afficher pour les enfant n entre le '+DateToStr(now-365)+' et le '+DateToStr(now)+' .',mtInformation,[MbOk],0);
  Convoquer.Enabled:=false;
  end
  Else   Convoquer.Enabled:=True;
  end;
//------------------------------------------------------------------------------
1:begin
  Qconvoc.close;
  Qconvoc.SQL.Clear;
  Qconvoc.sql.Add('Select * from enfant,EtatVaccinal,Calendier');
  Qconvoc.sql.Add('Where EtatVaccinal.NEtatc=Enfant.NEtatC and (EtatVaccinal.NetatC=Calendier.NEtatC)');
  Qconvoc.sql.Add('And (EtatVaccinal.Vpo="Non Administr") and (Calendier.DateVpo<=:N)');
  Qconvoc.sql.Add('And (EtatVaccinal.BCG="Administr") and Enfant.DateN Between :x And :y ');
  Qconvoc.Params[0].AsDate:=now;
  Qconvoc.Params[1].AsDate:=Now-365;
  Qconvoc.Params[2].AsDate:=now;
  Qconvoc.Open;
  Label1.Caption:=intToStr(QConvoc.RecordCount);
  if QConvoc.RecordCount=0 then begin
  MSG('Aucune Rsultat a afficher pour les enfants ns entre le '+DateToStr(now-365)+' et le '+DateToStr(now)+' .',mtInformation,[MbOk],'Remarque d''Information ...!!!',clblack,$00E4ECF1);
  // Messagedlg('Aucune Rsultat a afficher pour les enfant n entre le '+DateToStr(now-365)+' et le '+DateToStr(now)+' .',mtInformation,[MbOk],0);
    Convoquer.Enabled:=false;
  end
  Else   Convoquer.Enabled:=True;
  end;
//------------------------------------------------------------------------------
2 :begin
   QConvoc.close;
   QConvoc.SQL.Clear;
   Qconvoc.sql.Add('Select * from enfant,EtatVaccinal,Calendier ');
   Qconvoc.sql.Add('Where EtatVaccinal.NEtatc=Enfant.NEtatC and (EtatVaccinal.NetatC=Calendier.NEtatC) and (EtatVaccinal.DTCP1="Non Administr")');
   Qconvoc.sql.Add('And (Calendier.DateDTCP1<=:n) And (EtatVaccinal.vpo="Administr")');
   Qconvoc.sql.Add('And Enfant.DateN Between :x And :y');
   QConvoc.Params[0].AsDate:=now;
   QConvoc.Params[1].AsDate:=now-365;
   QConvoc.Params[2].AsDate:=now;
   QConvoc.Open;
   Label1.Caption:=intToStr(QConvoc.RecordCount);
   if QConvoc.RecordCount=0 then  begin
   MSG('Aucune Rsultat a afficher pour les enfant n entre le '+DateToStr(now-365)+' et le '+DateToStr(now)+' .',mtInformation,[MbOk],'Remarque d''Information ...!!!',clblack,$00E4ECF1);
   // Messagedlg('Aucune Rsultat a afficher pour les enfant n entre le '+DateToStr(now-365)+' et le '+DateToStr(now)+' .',mtInformation,[MbOk],0);
    Convoquer.Enabled:=false;
  end
  Else   Convoquer.Enabled:=True;

   end;
//------------------------------------------------------------------------------
3 :begin
   QConvoc.close;
   QConvoc.SQL.Clear;
   Qconvoc.sql.Add('Select * from enfant,EtatVaccinal,Calendier ');
   Qconvoc.sql.Add('Where EtatVaccinal.NEtatc=Enfant.NEtatC and (EtatVaccinal.NetatC=Calendier.NEtatC) and (EtatVaccinal.DTCP2="Non Administr")');
   Qconvoc.sql.Add('and (Calendier.DateDTCP2<=:n) And (EtatVaccinal.DTCP1="Administr")');
   Qconvoc.sql.Add(' And Enfant.DateN Between :x And :y');
   QConvoc.Params[0].AsDate:=now;
   QConvoc.Params[1].AsDate:=now-365;
   QConvoc.Params[2].AsDate:=now;
   QConvoc.Open;
   Label1.Caption:=intToStr(QConvoc.RecordCount);
   if QConvoc.RecordCount=0 then    begin
   MSG('Aucune Rsultat a afficher pour les enfant n entre le '+DateToStr(now-365)+' et le '+DateToStr(now)+' .',mtInformation,[MbOk],'Remarque d''Information ...!!!',clblack,$00E4ECF1);
   // Messagedlg('Aucune Rsultat a afficher pour les enfant n entre le '+DateToStr(now-365)+' et le '+DateToStr(now)+' .',mtInformation,[MbOk],0);
    Convoquer.Enabled:=false;
  end
  Else   Convoquer.Enabled:=True;
   end;
//------------------------------------------------------------------------------
4 :begin
   QConvoc.close;
   QConvoc.SQL.Clear;
   Qconvoc.sql.Add('Select * from enfant,EtatVaccinal,Calendier ');
   Qconvoc.sql.Add('Where EtatVaccinal.NEtatc=Enfant.NEtatC and (EtatVaccinal.NetatC=Calendier.NEtatC) and (EtatVaccinal.DTCP3="Non Administr")');
   Qconvoc.sql.Add('and (Calendier.DateDTCP3<=:n) And (EtatVaccinal.DTCP2="Administr")');
   Qconvoc.sql.Add(' And Enfant.DateN Between :x And :y');
   QConvoc.Params[0].AsDate:=now;
   QConvoc.Params[1].AsDate:=now-365;
   QConvoc.Params[2].AsDate:=now;
   QConvoc.Open;
   Label1.Caption:=intToStr(QConvoc.RecordCount);
   if QConvoc.RecordCount=0 then      begin
   MSG('Aucune Rsultat a afficher pour les enfant n entre le '+DateToStr(now-365)+' et le '+DateToStr(now)+' .',mtInformation,[MbOk],'Remarque d''Information ...!!!',clblack,$00E4ECF1);
   // Messagedlg('Aucune Rsultat a afficher pour les enfant n entre le '+DateToStr(now-365)+' et le '+DateToStr(now)+' .',mtInformation,[MbOk],0);
    Convoquer.Enabled:=false;
  end
  Else   Convoquer.Enabled:=True;
   end;
//------------------------------------------------------------------------------
5 :begin
   QConvoc.close;
   QConvoc.SQL.Clear;
   Qconvoc.sql.Add('Select * from enfant,EtatVaccinal,Calendier ');
   Qconvoc.sql.Add('Where EtatVaccinal.NEtatc=Enfant.NEtatC and (EtatVaccinal.NetatC=Calendier.NEtatC) and (EtatVaccinal.Var="Non Administr")');
   Qconvoc.sql.Add('and (Calendier.DateVar<=:n) And (EtatVaccinal.DTCP3="Administr")');
   Qconvoc.sql.Add(' And Enfant.DateN Between :x And :y');
   QConvoc.Params[0].AsDate:=now;
   QConvoc.Params[1].AsDate:=now-365;
   QConvoc.Params[2].AsDate:=now;
   QConvoc.Open;
   Label1.Caption:=intToStr(QConvoc.RecordCount);
   if QConvoc.RecordCount=0 then  begin
  MSG('Aucune Rsultat a afficher pour les enfant n entre le '+DateToStr(now-365)+' et le '+DateToStr(now)+' .', mtInformation,[MbOk],'Remarque d''Information ...!!!',clblack,$00E4ECF1);
  //Messagedlg('Aucune Rsultat a afficher pour les enfant n entre le '+DateToStr(now-365)+' et le '+DateToStr(now)+' .',mtInformation,[MbOk],0);
    Convoquer.Enabled:=false;
  end
  Else   Convoquer.Enabled:=True;
   end;
//------------------------------------------------------------------------------
  end;//case
end; //proceduer

procedure TF_convocation.FermClick(Sender: TObject);
begin
close;
end;

procedure TF_convocation.DBGrid1DrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
begin
if QConvoc.RecordCount<>0 then
 if gdSelected	in State then
begin
     DBGrid1.Canvas.Brush.Color := $00DFDFDF;
     DBGrid1.Canvas.Font.Color  := clNavy;
  end;
DBGrid1.DefaultDrawColumnCell(Rect,DataCol,Column,State);
end;

procedure TF_convocation.ConvoquerClick(Sender: TObject);
begin
Case rg.ItemIndex of
0:begin
with ImpConvoq do begin
  Qconv.close;
  Qconv.SQL.Clear;
  Qconv.sql.Add('Select * from enfant,EtatVaccinal ');
  Qconv.sql.Add( 'Where EtatVaccinal.NEtatc=Enfant.NEtatC and EtatVaccinal.bcg="Non Administr" and Enfant.DateN Between :x And :y ');
  Qconv.Params[0].AsDate:=Now-365;
  Qconv.Params[1].AsDate:=now;
  Qconv.Open;
  QRDate.caption:=DateToStr(Now+3) ;
  vac.Caption:='Admission du Vaccin BCG';
end;//with
  end;
//------------------------------------------------------------------------------
1:begin
With Impconvoq do begin
  Qconv.close;
  Qconv.SQL.Clear;
  Qconv.sql.Add('Select * from enfant,EtatVaccinal,Calendier');
  Qconv.sql.Add(' Where EtatVaccinal.NEtatc=Enfant.NEtatC and (EtatVaccinal.Vpo="Non Administr")');
  Qconv.sql.Add('And Calendier.DateVpo<=:N');
  Qconv.sql.Add(' and (EtatVaccinal.BCG="Administr") and Enfant.DateN Between :x And :y ');
  Qconv.Params[0].AsDate:=now;
  Qconv.Params[1].AsDate:=Now-365;
  Qconv.Params[2].AsDate:=now;
  Qconv.Open;
  QRDate.caption:=DateToStr(Now+3);
  vac.Caption:='Admission du Vaccin Vpo';
end;//with
  end;
//------------------------------------------------------------------------------
2 :begin
With Impconvoq do begin
   QConv.close;
   QConv.SQL.Clear;
   Qconv.sql.Add('Select * from enfant,EtatVaccinal,Calendier ');
   Qconv.sql.Add('Where EtatVaccinal.NEtatc=Enfant.NEtatC and (EtatVaccinal.NetatC=Calendier.NEtatC) and (EtatVaccinal.DTCP1="Non Administr")');
   Qconv.sql.Add('and (Calendier.DateDTCP1<=:n) And (EtatVaccinal.vpo="Administr")');
   Qconv.sql.Add(' And Enfant.DateN Between :x And :y');
   QConv.Params[0].AsDate:=now;
   QConv.Params[1].AsDate:=now-365;
   QConv.Params[2].AsDate:=now;
   QConv.Open;
  QRDate.caption:=DateToStr(Now+3);
  vac.Caption:='Admission du Vaccin DTCP1';
end;//with

   end;
//------------------------------------------------------------------------------
3 :begin
With Impconvoq do begin
   QConv.close;
   QConv.SQL.Clear;
   Qconv.sql.Add('Select * from enfant,EtatVaccinal,Calendier ');
   Qconv.sql.Add('Where EtatVaccinal.NEtatc=Enfant.NEtatC and (EtatVaccinal.NetatC=Calendier.NEtatC) and (EtatVaccinal.DTCP2="Non Administr")');
   Qconv.sql.Add('and (Calendier.DateDTCP2<=:n) And (EtatVaccinal.DTCP1="Administr")');
   Qconv.sql.Add(' And Enfant.DateN Between :x And :y');
   QConv.Params[0].AsDate:=now;
   QConv.Params[1].AsDate:=now-365;
   QConv.Params[2].AsDate:=now;
   QConv.Open;
  QRDate.caption:=DateToStr(Now+3);
  vac.Caption:='Admission du Vaccin DTCP2';
end;//with

   end;
//------------------------------------------------------------------------------
4 :begin
With Impconvoq do begin
   QConv.close;
   QConv.SQL.Clear;
   Qconv.sql.Add('Select * from enfant,EtatVaccinal,Calendier ');
   Qconv.sql.Add('Where EtatVaccinal.NEtatc=Enfant.NEtatC and (EtatVaccinal.NetatC=Calendier.NEtatC) and (EtatVaccinal.DTCP3="Non Administr")');
   Qconv.sql.Add('and (Calendier.DateDTCP3<=:n) And (EtatVaccinal.DTCP2="Administr")');
   Qconv.sql.Add(' And Enfant.DateN Between :x And :y');
   QConv.Params[0].AsDate:=now;
   QConv.Params[1].AsDate:=now-365;
   QConv.Params[2].AsDate:=now;
   QConv.Open;
   QRDate.caption:=DateToStr(Now+3);
  vac.Caption:='Admission du Vaccin DTCP3';
end;//with

   end;
//------------------------------------------------------------------------------
5 :begin
With Impconvoq do begin
   QConv.close;
   QConv.SQL.Clear;
   Qconv.sql.Add('Select * from enfant,EtatVaccinal,Calendier ');
   Qconv.sql.Add('Where EtatVaccinal.NEtatc=Enfant.NEtatC and (EtatVaccinal.NetatC=Calendier.NEtatC) and (EtatVaccinal.Var="Non Administr")');
   Qconv.sql.Add('and (Calendier.DateVar<=:n) And (EtatVaccinal.DTCP3="Administr")');
   Qconv.sql.Add(' And Enfant.DateN Between :x And :y');
   QConv.Params[0].AsDate:=now;
   QConv.Params[1].AsDate:=now-365;
   QConv.Params[2].AsDate:=now;
   QConv.Open;
   QRDate.caption:=DateToStr(Now+3);
  vac.Caption:='Admission du Vaccin Anti-Rougeoleux';
end;

   end;
//------------------------------------------------------------------------------
  end;//case
//------------------------------------------------------------------------------
ImpConvoq.QuickRep1.Preview;
end;
// -----------------------------------------------------------------------------
procedure TF_convocation.FormActivate(Sender: TObject);
var path : string;
begin
path := ExtractFilePath(Application.ExeName);

Res := TResourceStream.Create(hinstance,'MonFlash6',RT_RCDATA);
Res.SaveToFile(Path+'Test.swf');
Res.Free;
Flash1.Movie:=Path+'Test.swf';
deleteFile(path+'Test.swf');

end;

end.
