unit U_Recherche;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
   DBGrids, DBCtrls, ExtCtrls, StdCtrls, Mask, Db, DBTables,bnet,
  Grids, ComCtrls, Menus, dxCore, dxButton, OleCtrls,
  ShockwaveFlashObjects_TLB, TFlatHintUnit;

type
  TF_Recherche = class(TForm)
    QRech: TQuery;
    MNom: TMaskEdit;
    Label1: TLabel;
    CPrenom: TCheckBox;
    MPrenom: TMaskEdit;
    Label2: TLabel;
    Lancer: TButton;
    Paneldate: TPanel;
    P1: TDateTimePicker;
    P2: TDateTimePicker;
    Label3: TLabel;
    Label4: TLabel;
    DateLance: TButton;
    Panel2: TPanel;
    DSEnfant: TDataSource;
    Enfant: TTable;
    EnfantNEtatC: TStringField;
    EnfantNom: TStringField;
    EnfantPrenom: TStringField;
    EnfantSexe: TStringField;
    EnfantNompere: TStringField;
    EnfantDateN: TDateField;
    EnfantLieuN: TStringField;
    EnfantAdresse: TStringField;
    EnfantObserv: TStringField;
    DBGrid1: TDBGrid;
    DBGrid2: TDBGrid;
    DSQRech: TDataSource;
    QRechNEtatC: TStringField;
    QRechNom: TStringField;
    QRechPrenom: TStringField;
    QRechDateN: TDateField;
    QRechSexe: TStringField;
    QRechNompere: TStringField;
    QRechLieuN: TStringField;
    QRechAdresse: TStringField;
    QRechObserv: TStringField;
    MenuDBG: TPopupMenu;
    Proprits1: TMenuItem;
    Modifier1: TMenuItem;
    Supprimer1: TMenuItem;
    Nouveau1: TMenuItem;
    N2: TMenuItem;
    Fermer1: TMenuItem;
    N3: TMenuItem;
    QDeces: TQuery;
    N1: TMenuItem;
    DBNavigator1: TDBNavigator;
    Panel3: TPanel;
    Fermer: TButton;
    Lgrid: TLabel;
    Proprietes: TButton;
    Modif: TButton;
    Supp: TButton;
    R_Nouveau: TButton;
    dxButton2: TdxButton;
    dxButton4: TdxButton;
    dxButton5: TdxButton;
    dxButton1: TdxButton;
    dxButton3: TdxButton;
    dxButton6: TdxButton;
    Panel1: TPanel;
    Flash1: TShockwaveFlash;
    Panel4: TPanel;
    FHint1: TFlatHint;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FermerClick(Sender: TObject);
    procedure R_NouveauClick(Sender: TObject);
    procedure MNomKeyPress(Sender: TObject; var Key: Char);
    procedure MNomChange(Sender: TObject);
    procedure LAutreClick(Sender: TObject);
    procedure DBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure ProprietesClick(Sender: TObject);
    procedure ModifClick(Sender: TObject);
    procedure SuppClick(Sender: TObject);
    procedure CPrenomClick(Sender: TObject);
    procedure MPrenomChange(Sender: TObject);
    procedure LancerClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure DateLanceClick(Sender: TObject);
    procedure DBGrid1Exit(Sender: TObject);
    procedure DBGrid1ColEnter(Sender: TObject);
    procedure DBGrid2DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure DBGrid1CellClick(Column: TColumn);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure PaneldateClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  F_Recherche: TF_Recherche;
  Res : TResourceStream;
implementation

uses Principal, ProprEnfant, Modifier, supprim;

{$R *.DFM}
// -----------------------------------------------------------------------------
procedure TF_Recherche.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
F_Recherche.Enfant.Active:=False;
Form1.Panel1.enabled:=True;
Action:=CaFree;
end;
// -----------------------------------------------------------------------------
procedure TF_Recherche.FermerClick(Sender: TObject);
begin
F_Recherche.Close;
end;
// -----------------------------------------------------------------------------
procedure TF_Recherche.R_NouveauClick(Sender: TObject);
begin
F_Recherche.Close;
Form1.nouveauClick(Sender);
end;
// -----------------------------------------------------------------------------
procedure TF_Recherche.MNomKeyPress(Sender: TObject; var Key: Char);
begin
end;
// -----------------------------------------------------------------------------
procedure TF_Recherche.MNomChange(Sender: TObject);
begin
If Not Cprenom.Checked then
Begin
 QRech.Close;
 Qrech.SQL.Clear;
 Qrech.sql.Add('Select  * from enfant.DB Where Lower(enfant.DB.NOM) Like "'+MNom.Text+'%" OR Upper(enfant.DB.NOM) Like "'+MNom.Text+'%"');
 QRech.Open;
// -----------------------------------------------------------------------------
Enfant.SetRangeStart;
Enfant.FindNearest([MNom.text]) ;
Enfant.ApplyRange;
// -----------------------------------------------------------------------------
 if (Qrech.RecordCount= 0) then
 begin
   MSG('Ce Nom ne figure pas dans la base de donne', mtInformation,[MbOk],'Remarque d''Information ...!!!',clblack,$00E4ECF1);
//   Showmessage('');
   MNom.setfocus;
 end;
 End //CprenomChecked
// -----------------------------------------------------------------------------
 Else
 begin
 If (MNom.Text='') or (MPrenom.text='') then
 Lancer.Enabled:=false
 Else  Lancer.Enabled:=True;
 If (MNom.Text='') then
 Messagebeep(MB_OK);
 end;
 end;//Else
// -----------------------------------------------------------------------------
procedure TF_Recherche.LAutreClick(Sender: TObject);
begin
end;
// -----------------------------------------------------------------------------
procedure TF_Recherche.DBGrid1DrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
begin
// Change la couleur du texte et des cellules
If Enfant.RecordCount<>0 then
 if gdSelected	in State then
begin
     DBGrid1.Canvas.Brush.Color := $00DFDFDF;
     DBGrid1.Canvas.Font.Color  := clNavy;
     LGrid.Caption:=DBGrid1.Fields[0].Value;
  end;
DBGrid1.DefaultDrawColumnCell(Rect,DataCol,Column,State);
//------------------------------------------------------------------------------
Proprietes.Enabled:=True;
Modif.enabled:=True;
Supp.Enabled:=True;
end;
// -----------------------------------------------------------------------------
procedure TF_Recherche.ProprietesClick(Sender: TObject);
begin
PropEnf:=TpropEnf.Create(Application);
// -----------------------------------------------------------------------------
PropEnf.Enfant.TableName:=ExtractFilePath(Application.Exename)+'Enfant.DB';
PropEnf.cal.TableName:=ExtractFilePath(Application.Exename)+'Calendier.DB';
PropEnf.Etat.TableName:=ExtractFilePath(Application.Exename)+'etatVaccinal';
//------------------------------------------------------------------------------
PropEnf.enfant.Open;
PropEnf.etat.open;
PropEnf.Cal.Open;
// -----------------------------------------------------------------------------
PropEnf.Enfant.Findkey([F_Recherche.Lgrid.Caption]);
PropEnf.Etat.Findkey([F_Recherche.Lgrid.Caption]);
PropEnf.cal.Findkey([F_Recherche.Lgrid.Caption]);
// -----------------------------------------------------------------------------
try
PropEnf.ShowModal;
Finally
PropEnf.Free;
end;//finally
end;
// -----------------------------------------------------------------------------
procedure TF_Recherche.ModifClick(Sender: TObject);
begin
Modification := TModification.Create(Self);
Modification.Show;
//------------------------------------------------------------------------------
Modification.Enfant.TableName:=ExtractFilePath(Application.Exename)+'Enfant.DB';
Modification.cal.TableName:=ExtractFilePath(Application.Exename)+'Calendier.DB';
Modification.Etat.TableName:=ExtractFilePath(Application.Exename)+'etatVaccinal.DB';
// -----------------------------------------------------------------------------
Modification.Cvpo.Visible:=False;
Modification.CDtcp1.Visible:=False;
Modification.CDtcp2.Visible:=False;
Modification.CDtcp3.Visible:=False;
Modification.Cvar.Visible:=False;
Modification.Cr1.Visible:=false;
Modification.Cr2.Visible:=false;
// -----------------------------------------------------------------------------
Modification.PBcg.visible:=false ;
Modification.PVPO.visible:=false ;
Modification.PDTCP1.visible:=false ;
Modification.PDTCP2.visible:=false ;
Modification.PDTCP3.visible:=false ;
Modification.PVAR.visible:=false ;
Modification.Pr1.visible:=false ;
Modification.Pr1.visible:=false ;
// -----------------------------------------------------------------------------
Modification.enfant.Open;
Modification.Cal.open;
Modification.etat.open;
// -----------------------------------------------------------------------------
Modification.Enfant.Findkey([F_Recherche.Lgrid.Caption]);
Modification.Etat.Findkey([F_Recherche.Lgrid.Caption]);
Modification.cal.Findkey([F_Recherche.Lgrid.Caption]);
// -----------------------------------------------------------------------------
Modification.enfant.Edit;
Modification.Cal.Edit;
Modification.etat.Edit;
// -----------------------------------------------------------------------------
Modification.Enregistrer.Enabled:=False;
end;
// -----------------------------------------------------------------------------
procedure TF_Recherche.SuppClick(Sender: TObject);
begin
Supprime := TSupprime.Create(Application);
Supprime.Show;
//---- Initialisation -----------------------------------------------------------
Supprime.Enfant.TableName:=ExtractFilePath(Application.Exename)+'Enfant.DB';
Supprime.cal.TableName:=ExtractFilePath(Application.Exename)+'Calendier.DB';
Supprime.Etat.TableName:=ExtractFilePath(Application.Exename)+'etatVaccinal.DB';
// -----------------------------------------------------------------------------
Supprime.Cvpo.Visible:=False;
Supprime.CDtcp1.Visible:=False;
Supprime.CDtcp2.Visible:=False;
Supprime.CDtcp3.Visible:=False;
Supprime.Cvar.Visible:=False;
Supprime.Cr1.Visible:=false;
Supprime.Cr2.Visible:=false;
// -----------------------------------------------------------------------------
Supprime.PBcg.visible:=false ;
Supprime.PVPO.visible:=false ;
Supprime.PDTCP1.visible:=false ;
Supprime.PDTCP2.visible:=false ;
Supprime.PDTCP3.visible:=false ;
Supprime.PVAR.visible:=false ;
Supprime.Pr1.visible:=false ;
Supprime.Pr1.visible:=false ;
// Ouverture des tables --------------------------------------------------------
Supprime.enfant.Open;
Supprime.Cal.open;
Supprime.etat.open;
// -----------------------------------------------------------------------------
Supprime.Enfant.Findkey([F_Recherche.Lgrid.Caption]);
Supprime.Etat.Findkey([F_Recherche.Lgrid.Caption]);
Supprime.cal.Findkey([F_Recherche.Lgrid.Caption]);
// -----------------------------------------------------------------------------
Supprime.buttonEtatClick(Sender);
end;
// -----------------------------------------------------------------------------
procedure TF_Recherche.CPrenomClick(Sender: TObject);
begin
If cprenom.Checked then
begin
Label2.Visible:=true;
MPrenom.Visible:=true;
DBGrid2.Visible:= true;
DBGrid2.Align:= alClient;
Lancer.Visible:=True;
MPrenom.Text:='';
Mnom.Text:='';
Lancer.Enabled:=False;
end
// -----------------------------------------------------------------------------
Else begin
     MNom.Left:=280;
     Label1.Left:=142;
     DBGrid2.Visible:= False;
     Label2.Visible:=False;
     MPrenom.Visible:=False;
     DSEnfant.DataSet:= Enfant;
     Lancer.Visible:=False;
     Lancer.Enabled:=False;
     f_Recherche.DSEnfant.DataSet:=enfant;
     f_Recherche.DBGrid1.DataSource:=DSEnfant;
     end;
end;
// -----------------------------------------------------------------------------
procedure TF_Recherche.MPrenomChange(Sender: TObject);
begin
 If (MNom.Text='') or (MPrenom.text='') then
 Lancer.Enabled:=false
 Else  Lancer.Enabled:=True;
 If (MPrenom.Text='') then
 Messagebeep(MB_OK);
end;
// -----------------------------------------------------------------------------
procedure TF_Recherche.LancerClick(Sender: TObject);
begin
QRech.Close;
QRech.SQL.clear;
QRech.SQL.Add('Select  * from  ''enfant.DB'' Where ((Lower(''enfant.DB''.NOM) Like "'+Mnom.Text+'%") or (Upper(''enfant.DB''.NOM) Like "'+MNom.Text+'%")) AND ((Lower(''enfant.DB''.prenom) Like "'+MPrenom.Text+'%") or (Upper(''enfant.DB''.prenom) like "'+MPrenom.Text+'%"))');
QRech.Open;
if QRech.RecordCount=0 then
MSG('Cet Enfant ne figure pas dans la base de donne', mtInformation,[MbOk],'Remarque d''Information ...!!!',clblack,$00E4ECF1);
//Showmessage('')
end;
// -----------------------------------------------------------------------------
procedure TF_Recherche.FormShow(Sender: TObject);
begin
Form1.Panel1.enabled:=false;
end;
// -----------------------------------------------------------------------------
procedure TF_Recherche.DateLanceClick(Sender: TObject);
begin
//-------------------------------------------------------------------------
if datetostr(P1.Date)=DateToStr(P2.Date) then
begin
QRech.Sql.Clear;
QRech.Close;
QRech.SQL.add('Select * from enfant.DB where DateN=:z');
QRech.Params[0].AsDate:=P1.date;
QRech.Open;
If QRech.RecordCount = 0 then
MSG('Aucune Rsultat a Afficher pour les enfants ns le '+datetostr(P1.date), mtInformation,[MbOk],'Remarque d''Information ...!!!',clblack,$00E4ECF1);
//Showmessage(');
end
Else
begin
// -----------------------------------------------------------------------------
QRech.Sql.Clear;
QRech.Close;
QRech.SQL.add('Select * from enfant.DB where DateN BETWEEN :y  and :z');
QRech.Params[0].AsDate:=P1.date;
QRech.Params[1].asdate:=P2.date;
QRech.Open;
If QRech.RecordCount =0 then
MSG('Aucune Rsultat a Afficher entre le '+datetostr(P1.date)+' et le'+datetostr(P2.date), mtInformation,[MbOk],'Remarque d''Information ...!!!',clblack,$00E4ECF1);
//Showmessage(');
end;//else
end;
// -----------------------------------------------------------------------------
procedure TF_Recherche.DBGrid1Exit(Sender: TObject);
begin
Proprietes.Enabled:=false;
Modif.enabled:=False;
Supp.Enabled:=False;
end;
// -----------------------------------------------------------------------------
procedure TF_Recherche.DBGrid1ColEnter(Sender: TObject);
begin
Proprietes.Enabled:=True;
Modif.enabled:=True;
Supp.Enabled:=True;
end;
// -----------------------------------------------------------------------------
procedure TF_Recherche.DBGrid2DrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
begin
// Change la couleur du texte et des cellules
if QRech.RecordCount<>0 then
 if gdSelected	in State then
begin
     DBGrid2.Canvas.Brush.Color := $00DFDFDF;
     DBGrid2.Canvas.Font.Color  := clNavy;
     LGrid.Caption:=DBGrid2.Fields[0].Value;
  end;
DBGrid2.DefaultDrawColumnCell(Rect,DataCol,Column,State);
//------------------------------------------------------------------------------
Proprietes.Enabled:=True;
Modif.enabled:=True;
Supp.Enabled:=True;
end;
// -----------------------------------------------------------------------------
procedure TF_Recherche.DBGrid1CellClick(Column: TColumn);
begin
F_Recherche.Enfant.Refresh;
end;
// -----------------------------------------------------------------------------
procedure TF_Recherche.FormCreate(Sender: TObject);
begin
end;
// -----------------------------------------------------------------------------
procedure TF_Recherche.FormActivate(Sender: TObject);
var path : string;
begin
path := ExtractFilePath(Application.ExeName);

Res := TResourceStream.Create(hinstance,'MonFlash5',RT_RCDATA);
Res.SaveToFile(Path+'Test.swf');
Res.Free;
Flash1.Movie:=Path+'Test.swf';
deleteFile(path+'Test.swf');

end;
// -----------------------------------------------------------------------------
procedure TF_Recherche.PaneldateClick(Sender: TObject);
begin

end;
// -----------------------------------------------------------------------------
end.
